package com.tofly.base.api.feign;

import com.tofly.base.api.feign.factory.BaseTokenServiceFallbackFactory;
import com.tofly.common.core.constant.SecurityConstants;
import com.tofly.common.core.entity.ResultRespone;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @author Administrator
 * @date 2019/9/12  11:44
 */
@FeignClient(contextId = "baseTokenService",value = "tofly-auth", fallbackFactory = BaseTokenServiceFallbackFactory.class)
public interface BaseTokenService {

    /**
     * 分页查询token 信息
     *
     * @param params 分页参数
     * @param from   内部调用标志
     * @return page
     */
    @PostMapping("/token/page")
    ResultRespone getTokenPage(@RequestBody Map<String, Object> params, @RequestHeader(SecurityConstants.FROM) String from);

    /**
     * 删除token
     *
     * @param token token
     * @param from  调用标志
     * @return
     */
    @DeleteMapping("/token/{token}")
    ResultRespone<Boolean> removeToken(@PathVariable("token") String token, @RequestHeader(SecurityConstants.FROM) String from);
}
