package com.tofly.base.api.feign.fallback;

import com.tofly.base.api.feign.BaseTokenService;
import com.tofly.common.core.entity.ResultRespone;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @author Administrator
 * @date 2019/9/12  11:45
 */
@Slf4j
@Component
public class BaseTokenServiceFallbackImpl implements BaseTokenService {
    @Setter
    private Throwable cause;

    /**
     * 分页查询token 信息
     *
     * @param params 分页参数
     * @param from   内部调用标志
     * @return page
     */
    @Override
    public ResultRespone getTokenPage(Map<String, Object> params, String from) {
        log.error("调用认证中心查询token 失败", cause);
        return null;
    }

    /**
     * 删除token
     *
     * @param s
     * @param id
     * @return
     */
    @Override
    public ResultRespone<Boolean> removeToken(String s, String id) {
        log.error("删除token 失败 {}", id, cause);
        return null;
    }
}
