package com.tofly.common.core.entity;


import com.tofly.common.core.constant.ResponeStatus;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.io.Serializable;

/**
 * @author Administrator
 * @date 2019/8/30  15:27
 */
@ToString
public class ResultRespone<T> implements Serializable {
    private static final long serialVersionUID = 1L;

    @Getter
    @Setter
    private int code;

    @Getter
    @Setter
    private String msg;

    @Getter
    @Setter
    private T data;

    public static <T> ResultRespone<T> success() {
        return restResult(null, ResponeStatus.SUCCESS.getCode(), null);
    }

    public static <T> ResultRespone<T> success(T data) {
        return restResult(data, ResponeStatus.SUCCESS.getCode(), null);
    }

    public static <T> ResultRespone<T> success(T data, String msg) {
        return restResult(data, ResponeStatus.SUCCESS.getCode(), msg);
    }

    public static <T> ResultRespone<T> failed() {
        return restResult(null, ResponeStatus.FAIL.getCode(), null);
    }

    public static <T> ResultRespone<T> failed(String msg) {
        return restResult(null, ResponeStatus.FAIL.getCode(), msg);
    }

    public static <T> ResultRespone<T> failed(T data) {
        return restResult(data, ResponeStatus.FAIL.getCode(), null);
    }

    public static <T> ResultRespone<T> failed(T data, String msg) {
        return restResult(data, ResponeStatus.FAIL.getCode(), msg);
    }

    private static <T> ResultRespone<T> restResult(T data, int code, String msg) {
        ResultRespone<T> apiResult = new ResultRespone<>();
        apiResult.setCode(code);
        apiResult.setData(data);
        apiResult.setMsg(msg);
        return apiResult;
    }
}
