package com.tofly.common.core.util;

import com.alibaba.fastjson.JSONObject;
import com.sun.xml.internal.ws.util.UtilException;

import java.io.*;
import java.net.*;
import java.util.Map;

public class HttpURL {
	
	public static String  FILE_URL_PREFIX="FILE_URL_PREFIX";

	public static String getContent(String path, String param) throws IOException {
		// 打开连接
		URL url = new URL(path);
		URLConnection urlConnection = url.openConnection();
		HttpURLConnection httpUrlConnection = (HttpURLConnection) urlConnection;
		httpUrlConnection.setRequestProperty("Charset", "UTF-8");
		httpUrlConnection.setRequestProperty("Content-Type","application/json;charset=UTF-8");
		if (param != null) {
			// 以POST方式处理
			httpUrlConnection.setDoOutput(true);
			httpUrlConnection.setDoInput(true);
			httpUrlConnection.setUseCaches(false);
			httpUrlConnection.setRequestMethod("POST");
			// 发送post请求
			OutputStream outputStream = httpUrlConnection.getOutputStream();
			PrintWriter printWriter = new PrintWriter(outputStream);
			if (param != null) {
				printWriter.write(param);
			}
			printWriter.flush();
			printWriter.close();
			outputStream.close();
		} else {
			// 默认以GET方式处理
		}

		// 接收处理结果反馈
		String resultString = "";
		// long startTime = System.currentTimeMillis();
		InputStream inputStream = httpUrlConnection.getInputStream();
		// long endTime = System.currentTimeMillis();
		// System.out.println(endTime - startTime);

		int responseCode = httpUrlConnection.getResponseCode();
		if (responseCode == HttpURLConnection.HTTP_OK) {
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"UTF-8"));
			String line = bufferedReader.readLine();
			while (line != null) {
				resultString += line;
				line = bufferedReader.readLine();
			}
			bufferedReader.close();
		} else {
			// TODO: 改为日志
			resultString="服务返回异常：" + responseCode;
		}
		inputStream.close();
		httpUrlConnection.disconnect();
		return resultString;
	}
	
	
	public static String getContent(String path, Map param) throws IOException {
		/*throw new IOException();*/
		JSONObject obj = new JSONObject(param);
		return getContent(path,obj.toString());
		
	}

	/**
	 * 获得path部分<br>
	 *
	 * @param uriStr URI路径
	 * @return path
	 * @exception UtilException 包装URISyntaxException
	 */
	public static String getPath(String uriStr) {
		URI uri = null;
		try {
			uri = new URI(uriStr);
		} catch (URISyntaxException e) {
			throw new UtilException(e);
		}
		return uri.getPath();
	}







	public static void main(String[] args) throws IOException {

	}
}
